import unittest
from datetime import datetime, date, timedelta

import pytz
from mock import Mock

from postgres_alerts.rule import Rule


class TestUtils(unittest.TestCase):

    def test_evaluation(self):
        last_run = datetime.now(pytz.timezone("Europe/Prague")) - timedelta(minutes=6)
        self.assertTrue(Rule.evaluate(Rule(1, last_run, '*/5 * * * *', 'TEST', '', '=', '', False, '')))

        last_run = (datetime
                    .combine(date.today(), datetime.time(datetime.strptime('17:00:00', '%H:%M:%S')))
                    .replace(tzinfo=pytz.timezone("Europe/Prague")))
        self.assertFalse(Rule.evaluate(Rule(2, last_run, '0 16 * * *', 'TEST2', '', '=', '', False, '')))

        # test that timezones are handled correctly
        last_run = datetime.now()  # has no timezone
        Rule.evaluate(Rule(2, last_run, '0 16 * * *', 'TEST3', '', '=', '', False, ''))

        # test that None is handled
        last_run = None  # has no timezone
        Rule.evaluate(Rule(2, last_run, '0 16 * * *', 'TEST3', '', '=', '', False, ''))

    def test_calculate_status(self):
        sql_row = {'id': 9999999,
                   'last_run_datetime': datetime(2020, 3, 26, 15, 47, 52, 826626),
                   'cron': '* */6 * * 1-5',
                   'name': 'TEST RULE',
                   'query_left': "SELECT 0",
                   'operand': '=',
                   'value_right': 0.0,
                   'debug': True,
                   'alert_message': ''}
        cur = Mock()
        cur.fetchone = Mock(return_value=(0,))

        result = Rule.calculate_status(Rule(**sql_row), cur)
        self.assertFalse(result.is_alerting())
        self.assertEqual(result.get_left(), 0)

        sql_row.update({'operand': '>'})
        result = Rule.calculate_status(Rule(**sql_row), cur)
        self.assertTrue(result.is_alerting())

        cur.fetchone = Mock(return_value=(0, 'Custom message generated by sql'))
        result = Rule.calculate_status(Rule(**sql_row), cur)
        self.assertEqual(result.get_message(), 'Custom message generated by sql')
        self.assertTrue(result.is_alerting())

        cur.fetchone = Mock(return_value=(0, 5))
        result = Rule.calculate_status(Rule(**sql_row), cur)
        self.assertEqual(result.get_message(), '5')

        cur.fetchone = Mock(return_value=(None, 'Custom message generated by sql'))
        result = Rule.calculate_status(Rule(**sql_row), cur)
        self.assertTrue(result.is_error())

        sql_row.update({'value_right': 'TEXT'})
        result = Rule.calculate_status(Rule(**sql_row), cur)
        self.assertTrue(result.is_error())


if __name__ == '__main__':
    unittest.main()
